'$INCLUDE 'cdi_incl.cbh'
 
sub main
 
   cv_osl = 0
   null_ptr = 0
 
	dim i as integer, l as long
	dim x as integer, z as integer
	dim lbuffer as CDI_LAYER
	dim dwg as CDI_WORLD_RECT
	dim var1 as integer, var2 as integer, var3 as integer
	dim offset as integer
	dim startlyr as integer, endlyr as integer, newpos as integer

Begin Dialog UserDialog  150, 100, 137, 113

   Caption  "Move layers"

	Text  4, 4, 105, 9,  "Define Range of layers to move:"

	Text  59, 20, 7, 9,  "to"

	TextBox  35, 19, 21, 12,  .TextBox1

	TextBox  68, 19, 21, 12,  .TextBox2

	Text  5, 39, 86, 9,  "First layer of new position:"

	TextBox  51, 53, 27, 12,  .TextBox3

	CheckBox  8, 71, 120, 11,  "Do not relocate layer properties", .CheckBox1

	ButtonGroup .But

	Button  7, 87, 48, 14, "OK"

	Button  74, 87, 48, 14, "Cancel"

End Dialog 


Dim Dlg as UserDialog

Dialog Dlg


	if dlg.but = 1 then goto OUT_OF_HERE
	startlyr = val(dlg.textbox1)
	endlyr = val(dlg.textbox2)
	newpos = val(dlg.textbox3)

	if startlyr < 1 or endlyr > 255 then goto RANGE_ERROR
	if newpos < 1 or newpos + endlyr - startlyr > 255 then goto RANGE_ERROR

	if newpos < startlyr then
		var1 = startlyr
		var2 = endlyr
		var3 = 1
	else
		var1 = endlyr
		var2 = startlyr
		var3 = -1
	end if

	offset = newpos - startlyr

	call CdiGetDBExtents(dwg)
	c1.x = dwg.left
	c1.y = dwg.top
	c2.x = dwg.right
	c2.y = dwg.bottom

for z = var1 to var2 step var3
	call CdiOslClear(cv_osl)
	msg$ = "Transferring objects on layer" + str$(z) + " to Layer" + str$(z + offset) + chr$(0)
	call CdiPutMsg(msg$)

	i = CdiSetActLayer(z)
	i = CdiNestedMenuEntry(IDM_VIEW_LAYERS_ACTIVE,button_hit,menu_hit)
	i = CdiSelectByWindow(cv_osl,prompt_1,prompt_2,OBJECT_SELECTION,CDI_TRUE,CDI_TRUE,c1,c2,CDI_SEL2D_ALL)
	if dlg.checkbox1 = 0 then
		i = CdiGetLayer(lbuffer, z)
		i = CdiSetLayer(lbuffer, z + offset)
		lbuffer.name = ltrim$(str$(z)) + chr$(0)
		i = CdiSetLayer(lbuffer, z)
	end if
	if CdioslCount(cv_osl) > 0 then
		i = CdiObjLayer(cv_osl,z + offset,CDI_OBJECT_COLOR)
	end if
next z
goto OUT_OF_HERE

RANGE_ERROR:
	msg$ = "A error in the range selection"
	msgbox msg$

OUT_OF_HERE:
	call CdiOslClear(cv_osl)
	i = CdiNestedMenuEntry(IDM_VIEW_LAYERS_ALL,button_hit,menu_hit)
	msgbox "Macro Run Completed"	
end sub
